## frama-c 20151002+magnesium+dfsg

=== Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2015                                               #
#    CEA (Commissariat à l'énergie atomique et aux énergies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# This file is the main makefile of Frama-C.

FRAMAC_SRC=.
MAKECONFIG_DIR=share

include share/Makefile.common
include share/Makefile.dynamic_config.internal

#Check share/Makefile.config available
ifndef FRAMAC_TOP_SRCDIR
$(error "You should run ./configure first (or autoconf if there is no configure)")
endif

###################
# Frama-C Version #
###################

VERSION:=$(shell $(SED) -e 's/\(\.*\)/\1/' VERSION)
VERSION_PREFIX = $(shell $(SED) -e 's/\([a-zA-Z]\+-[0-9]\+\).*/\1/' VERSION)

ifeq ($(findstring +dev,$(VERSION)),+dev)
DEVELOPMENT=yes
else
DEVELOPMENT=no
endif

###########################
# Global plugin variables #
###########################

# the directory where compiled plugin files are stored
PLUGIN_GUI_LIB_DIR= $(PLUGIN_LIB_DIR)/gui

# the directory where the other Makefiles are
FRAMAC_SHARE	= share

# set it to yes to tell Makefile.dynamic than we come from here
FRAMAC_MAKE	=yes

# Shared lists between Makefile.plugin and Makefile :
# initialized them as "simply extended variables" (with :=)
# for a correct behavior of += (see section 6.6 of GNU Make manual)
PLUGIN_LIST	:=
PLUGIN_GENERATED_LIST:=
PLUGIN_DYN_EXISTS:="no"
PLUGIN_DYN_LIST :=
PLUGIN_CMO_LIST	:=
PLUGIN_CMX_LIST	:=
PLUGIN_META_LIST :=
PLUGIN_DYN_CMO_LIST :=
PLUGIN_DYN_CMX_LIST :=
PLUGIN_INTERNAL_CMO_LIST:=
PLUGIN_INTERNAL_CMX_LIST:=
PLUGIN_DEP_GUI_CMO_LIST:=
PLUGIN_DEP_GUI_CMX_LIST:=
PLUGIN_GUI_CMO_LIST:=
PLUGIN_GUI_CMX_LIST:=
PLUGIN_DYN_DEP_GUI_CMO_LIST:=
PLUGIN_DYN_DEP_GUI_CMX_LIST:=
PLUGIN_DYN_GUI_CMO_LIST :=
PLUGIN_DYN_GUI_CMX_LIST :=
PLUGIN_TYPES_CMO_LIST :=
PLUGIN_TYPES_CMX_LIST :=
PLUGIN_DEP_LIST:=
PLUGIN_DOC_LIST :=
PLUGIN_DOC_DIRS :=
PLUGIN_DISTRIBUTED_LIST:=
PLUGIN_DIST_TARGET_LIST:=
PLUGIN_DIST_DOC_LIST:=
PLUGIN_BIN_DOC_LIST:=
PLUGIN_DIST_EXTERNAL_LIST:=
PLUGIN_TESTS_LIST:=
PLUGIN_DISTRIBUTED_NAME_LIST:=

CEA_WP:=
UNMODIFIED_WHY3:=
MODIFIED_WHY3:=

###############################
# Additional global variables #
###############################

# put here any config option for the binary distribution outside of
# plugins
CONFIG_DISTRIB_BIN:=

# Directories containing some source code
SRC_DIRS= ptests $(PLUGIN_LIB_DIR)

# Directory containing source code documentation
DOC_DIR	= doc/code

# Source files to document
MODULES_TODOC=

# Directories containing some source code
SRC_DIRS+= $(FRAMAC_SRC_DIRS)

# Directories to include when compiling
INCLUDES=$(addprefix -I , $(FRAMAC_SRC_DIRS)) -I $(PLUGIN_LIB_DIR) -I lib

# Directories to include for ocamldep
# Remove -I +.* and -I C:/absolute/win/path
INCLUDES_FOR_OCAMLDEP=$(addprefix -I , $(FRAMAC_SRC_DIRS)) \
                      -I $(PLUGIN_LIB_DIR) -I lib

# Ocamldep flags
DEP_FLAGS= $(shell echo $(INCLUDES_FOR_OCAMLDEP) \
             | $(SED) -e "s/-I *.:[^ ]*//g" -e "s/-I *+[^ ]*//g")

# Files for which dependencies are computed
FILES_FOR_OCAMLDEP+=$(PLUGIN_LIB_DIR)/*.mli \
		$(addsuffix /*.mli, $(FRAMAC_SRC_DIRS)) \
		$(addsuffix /*.ml, $(FRAMAC_SRC_DIRS))

# Developments flags to be used by ocamlc and ocamlopt when compiling Frama-C
# itself. For development versions, we add -warn-error for most warnings
# (or all if WARN_ERROR_ALL is set). -warn-error has effect only for warnings
# that are explicitely set using '-w'. For Frama-C, this is done in
# share/Makefile.common, as active warnings are inherited by plugins.
ifeq ($(DEVELOPMENT),yes)
ifeq ($(WARN_ERROR_ALL),yes) # To be set on the command-line
DEV_WARNINGS= -warn-error +a
else
DEV_WARNINGS= -warn-error +a-32-33-34-35-36-37-38-39
endif #WARN_ERROR_ALL
DEV_FLAGS=$(FLAGS) $(DEV_WARNINGS)
else
DEV_FLAGS=$(FLAGS)
endif #DEVELOPMENT

BFLAGS	= $(DEV_FLAGS) $(DEBUG) $(INCLUDES) $(OUNIT_COMPILER_BYTE) \
		$(FRAMAC_USER_FLAGS)
OFLAGS	= $(DEV_FLAGS) $(DEBUG) $(INCLUDES) $(OUNIT_COMPILER_OPT) -compact \
		$(FRAMAC_USER_FLAGS)

BLINKFLAGS += $(BFLAGS) -linkall -custom
OLINKFLAGS += $(OFLAGS) -linkall

DOC_FLAGS= -colorize-code -stars -m A -hide-warnings $(INCLUDES) $(GUI_INCLUDES)

ifeq ($(HAS_OCAML402),yes)
	DOC_FLAGS += -w -3
endif

# Libraries generated by Frama-C
GEN_BYTE_LIBS=
GEN_OPT_LIBS=

# Libraries used in Frama-C
EXTRA_OPT_LIBS:=
INCLUDE_FINDLIB:=$(shell ocamlfind query -i-format findlib)
INCLUDES+= $(INCLUDE_FINDLIB)
BYTE_LIBS = nums.cma unix.cma bigarray.cma str.cma findlib.cma dynlink.cma \
	$(GEN_BYTE_LIBS)
OPT_LIBS = nums.cmxa unix.cmxa bigarray.cmxa str.cmxa findlib.cmxa \
	$(EXTRA_OPT_LIBS)

ifeq ("$(NATIVE_DYNLINK)","yes")
OPT_LIBS+= dynlink.cmxa
endif

OPT_LIBS+= $(GEN_OPT_LIBS)

ICONS:= $(addprefix share/, \
		frama-c.ico frama-c.gif unmark.png )

FEEDBACK_ICONS_NAMES:= \
		never_tried.png \
		unknown.png \
		surely_valid.png \
		surely_invalid.png \
		considered_valid.png \
		valid_under_hyp.png \
		invalid_under_hyp.png \
		invalid_but_dead.png \
		unknown_but_dead.png \
		valid_but_dead.png \
		inconsistent.png \
		switch-on.png \
		switch-off.png

FEEDBACK_ICONS_DEFAULT:= \
	$(addprefix share/theme/default/, $(FEEDBACK_ICONS_NAMES))
FEEDBACK_ICONS_COLORBLIND:= \
	$(addprefix share/theme/colorblind/, $(FEEDBACK_ICONS_NAMES))

ROOT_LIBC_DIR:= share/libc
LIBC_SUBDIRS:= sys netinet linux net arpa
LIBC_DIR:= $(ROOT_LIBC_DIR) $(addprefix $(ROOT_LIBC_DIR)/, $(LIBC_SUBDIRS))
FREE_LIBC:= \
	share/*.h share/*.c \
	$(addsuffix /*.h, $(LIBC_DIR)) \
	$(ROOT_LIBC_DIR)/__fc_builtin_for_normalization.i

NONFREE_LIBC:= $(addsuffix /*.[ci], $(LIBC_DIR))


# Checks that all .h can be included multiple times.
ALL_LIBC_HEADERS:=$(wildcard share/*.h $(addsuffix /*.h, $(LIBC_DIR)))

check-libc: bin/toplevel.$(OCAMLBEST)$(EXE)
	@echo "checking libc..."; \
	 EXIT_VALUE=0; \
	 for file in $(ALL_LIBC_HEADERS); do \
	   echo "#include \"$$file\"" > check-libc.c; \
	   echo "#include \"$$file\"" >> check-libc.c; \
	   FRAMAC_SHARE=share bin/toplevel.$(OCAMLBEST)$(EXE) \
           -cpp-extra-args="-Ishare/libc -nostdinc" check-libc.c \
               > $$(basename $$file .h).log 2>&1; \
	   if test $$? -ne 0; then \
	     if grep -q -e '#error "Frama-C:' $$file; then : ; \
	     else \
	       echo "$$file cannot be included twice. \
Output is in $$(basename $$file .h).log"; \
	       EXIT_VALUE=1; \
	     fi; \
	   else \
	     rm $$(basename $$file .h).log; \
           fi; \
	 done; \
	 rm check-libc.c; \
	 exit $$EXIT_VALUE

clean-check-libc:
	$(RM) *.log

# Kernel files to be included in the distribution.
# Plug-ins should use PLUGIN_DISTRIB_EXTERNAL if they export something else
# than *.ml* files in their directory.
# NB: configure for the distribution is generated in the distrib directory
# itself, rather than copied: otherwise, it could include references to
# non-distributed plug-ins.
DISTRIB_FILES:=\
      bin/*2*.sh							\
      share/frama-c.WIN32.rc share/frama-c.Unix.rc                      \
      $(ICONS) $(FEEDBACK_ICONS_DEFAULT) $(FEEDBACK_ICONS_COLORBLIND)	\
      man/frama-c.1 doc/README			\
      doc/code/docgen_*.ml						\
      doc/code/*.css doc/code/intro_plugin.txt				\
      doc/code/intro_plugin_D_and_S.txt                                 \
      doc/code/intro_plugin_default.txt                                 \
      doc/code/intro_kernel_plugin.txt doc/code/intro_occurrence.txt	\
      doc/code/intro_pdg.txt doc/code/intro_scope.txt			\
      doc/code/intro_slicing.txt doc/code/intro_sparecode.txt		\
      doc/code/intro_wp.txt doc/code/toc_head.htm			\
      doc/code/toc_tail.htm                                             \
      $(filter-out                                                      \
         $(addprefix doc/code/print_api/,                              \
               dynamic_plugins.mli grammar.ml grammar.mli lexer.ml),    \
         $(wildcard doc/code/print_api/*.ml*))                          \
      doc/code/print_api/Makefile                                       \
      doc/Makefile                                                      \
      $(filter-out ptests/ptests_config.ml, $(wildcard ptests/*.ml*))   \
      configure.in Makefile Makefile.generating 			\
      Changelog config.h.in	\
      VERSION licenses/* 						\
      $(FREE_LIBC)                                                      \
      share/acsl.el share/configure.ac					\
      share/Makefile.config.in share/Makefile.common                    \
      share/Makefile.generic			                        \
      share/Makefile.plugin share/Makefile.dynamic			\
      share/Makefile.dynamic_config.external				\
      share/Makefile.dynamic_config.internal		   		\
      $(filter-out src/kernel_internals/runtime/config.ml,              \
	  $(wildcard src/kernel_internals/runtime/*.ml*))               \
      src/kernel_services/abstract_interp/*.ml*                         \
      src/plugins/gui/*.ml*                                             \
      $(filter-out src/libraries/stdlib/integer.ml                      \
	src/libraries/stdlib/FCDnlink.ml,                               \
        $(wildcard src/libraries/stdlib/*.ml*))                         \
      $(wildcard src/libraries/utils/*.ml*)                             \
      src/libraries/utils/*.c                                           \
      src/libraries/project/*.ml*                                       \
      $(filter-out src/kernel_internals/parsing/check_logic_parser.ml, \
	  src/kernel_internals/parsing/*.ml*)                          \
      src/kernel_internals/typing/*.ml*                               \
      src/kernel_services/ast_data/*.ml*                                \
      src/kernel_services/ast_queries/*.ml*                          \
      src/kernel_services/ast_printing/*.ml*                            \
      src/kernel_services/cmdline_parameters/*.ml*                      \
      src/kernel_services/analysis/*.ml*                                \
      src/kernel_services/ast_transformations/*.ml*                                 \
      src/kernel_services/plugin_entry_points/*.ml*                     \
      src/kernel_services/visitors/*.ml*                                \
      src/kernel_services/parsetree/*.ml*                                    \
      src/libraries/datatype/*.ml*                                      \
      bin/sed_get_make_major bin/sed_get_make_minor                     \
      INSTALL INSTALL_WITH_WHY .make-clean	                        \
      .make-clean-stamp .make-ocamlgraph-stamp .force-reconfigure 	\
      opam/* opam/files/*

=== doc/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2015                                               #
#    CEA (Commissariat à l'énergie atomique et aux énergies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# This file just download the manuals in the released version

all:download


FRAMAC_SRC=..
MAKECONFIG_DIR=$(FRAMAC_SRC)/share

include $(FRAMAC_SRC)/share/Makefile.common

DOCDIR ?= "$(DESTDIR)${prefix}/share/doc"
FRAMAC_DOCDIR ?= $(DOCDIR)/frama-c

###################
# Frama-C Version #
###################

VERSION=$(shell $(SED) -e 's/\\(.*\\)/\\1/' $(FRAMAC_SRC)/VERSION)

ifeq ($(findstring +dev,$(VERSION)),+dev)
DEVELOPMENT=yes
else
DEVELOPMENT=no
endif

###

.PHONY: force


MANUALS=acsl

#MANUALS that depend on the frama-c version
VERSIONED_MANUALS=acsl-implementation aorai-manual rte-manual	\
		  wp-manual metrics-manual user-manual		\
		  plugin-development-guide value-analysis

FILES= $(addprefix manuals/, \
	 $(addsuffix -$(VERSION).pdf, $(VERSIONED_MANUALS)) \
         $(addsuffix .pdf, $(MANUALS)) \
	)


ifeq ($(DEVELOPMENT),yes)

download: force
	@echo "You can't download the manuals in this way for the development version"

else

download: force
	$(MKDIR) manuals
	wget -nv -N -P manuals \
	  $(addprefix http://frama-c.com/download/,$(addsuffix -$(VERSION).pdf, $(VERSIONED_MANUALS))) \
	  $(addprefix http://frama-c.com/download/,$(addsuffix .pdf, $(MANUALS)))

endif

install:
	$(MKDIR) $(FRAMAC_DOCDIR)
	$(CP) $(FILES) $(FRAMAC_DOCDIR)

=== tests/more_wp/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2009                                               #
#    CEA   (Commissariat  l'nergie Atomique)                           #
#    INRIA (Institut National de Recherche en Informatique et en         #
#           Automatique)                                                 #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version v2.1                #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

FD=../..
WD=$(FD)/tests/more_wp
WHYDIR=$(FD)/why

EXEC=$(FD)/bin/toplevel.opt
CMD=FRAMAC_SHARE=$(FD)/share WHYLIB=$(WHYDIR)/lib WHYBIN=$(WHYDIR)/bin/why.opt WHYDP=$(WHYDIR)/bin/why-dp.opt $(EXEC) -journal-disable -wp-verbose 1 -wp-no-bot -wp-proof
#CMD=FRAMAC_SHARE=$(FD)/share $(EXEC) -journal-disable -wp-verbose 1 

all : res_0 res_2 

.PHONY : all 

JD=$(FD)/tests/jessie
JFILES=$(wildcard $(JD)/*.c)

WP_FILES=$(JFILES:$(JD)/%.c=$(WD)/%.X)
STATUS=valid invalid unknown timeout failure
RES_FILES=$(STATUS:%=%.X) failed.X errors.X

LOG_0=$(WP_FILES:%.X=%.0.log)
ERR_0=$(WP_FILES:%.X=%.0.err)
RES_0 = $(RES_FILES:%.X=%.0)
.PRECIOUS :  $(LOG_0) $(ERR_0)
.PHONY : RES_0 

LOG_0 : $(LOG_0)
ERR_0 : $(ERR_0)
RES_0 : $(RES_0)

LOG_2=$(WP_FILES:%.X=%.2.log)
ERR_2=$(WP_FILES:%.X=%.2.err)
RES_2 = $(RES_FILES:%.X=%.2)
.PRECIOUS :  $(LOG_2) $(ERR_2)
.PHONY : RES_2

LOG_2 : $(LOG_2)
ERR_2 : $(ERR_2)
RES_2 : $(RES_2)

LOG_0 ERR_0 LOG_2 ERR_2 :
	# we need to have a way to store the timestamp
	touch $@

$(WD)/%.0.log $(WD)/%.0.err : $(JD)/%.c $(EXEC)
	-$(CMD) -wp-mm 0 $< > $(WD)/$*.0.log 2> $(WD)/$*.0.err

$(WD)/%.2.log $(WD)/%.2.err : $(JD)/%.c $(EXEC) $(WD)/%.2.no
	@echo "Don't run test M2 for $<"
	touch $@

$(WD)/%.2.log $(WD)/%.2.err : $(JD)/%.c $(EXEC)
	-$(CMD) -wp-mm 2 $< > $(WD)/$*.2.log 2> $(WD)/$*.2.err

errors.% : ERR_%
	-grep Fatal $($<) > $@
	-grep Unbound $($<) >> $@
	-grep "Could not run why" $($<) >> $@
	-grep "Could not run why" $(LOG_$*) >> $@
	echo "TOTAL errors = `wc -l $@`" >> $@

failed.% : LOG_%
	-grep Failed $($<) > $@
	echo "TOTAL failed = `wc -l $@`" >> $@

%.0 : $(LOG_0)
	-grep $* $+ | grep "%" | grep -v " 0%" > $@
	echo "TOTAL $* = \
	  `gawk 'BEGIN { cpt = 0; } { cpt += $$3; } END { print cpt; }' \
	  $@`" >> $@

%.2 : $(LOG_2)
	-grep $* $+ | grep "%" | grep -v " 0%" > $@
	echo "TOTAL $* = \
	  `gawk 'BEGIN { cpt = 0; } { cpt += $$3; } END { print cpt; }' \
	  $@`" >> $@

res_% : RES_%
	@echo "=== Results for model $* :"
	grep "TOTAL" $($<) > $@
	cat $@

failed.%.m : failed.% Makefile
	cat $< \
	  | grep -v " [cfg] switch handling" \
	  | grep -v " char constant expr" \
	  | grep -v " string constant expr" \
	  | grep -v " cast" \
	  | grep -v " logic function with labels" \
	  | grep -v " predicate with label" \
	  | grep -v " fol term range" \
	  | grep -v " unsupported C or logic type" \
	  > $@


# identification of "normal" (or known) failed cases
f0 : failed.0.m
	-cat $< \
	  | grep -v ": indirect assign" \
	  | grep -v ": indirect access" \
	  | grep -v ": no assigns clause in called function" \

f2 : failed.2.m
	-cat $< \
	  | grep -v ": pointer to logic_type not implemented" \

clean :
	rm -f $(LOG_0) $(ERR_0) $(RES_0) LOG_0 ERR_0 RES_0
	rm -f $(LOG_2) $(ERR_2) $(RES_2) LOG_2 ERR_2 RES_2
	rm -f frama_c_journal.ml
	rm -f failed.*.m res_0 res_2
	rm -f gwhy.cache

# .SILENT :

=== doc/code/print_api/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2015                                               #
#    CEA (Commissariat à l'énergie atomique et aux énergies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# Print_api plugin
##################

# Frama-C should be properly installed with "make install"
# befor any use of this makefile

ifndef FRAMAC_SHARE
FRAMAC_SHARE	:=$(shell frama-c.byte -print-path)
endif
ifndef FRAMAC_LIBDIR
FRAMAC_LIBDIR	:=$(shell frama-c.byte -print-libpath)
endif

PLUGIN_DIR	?= .
PLUGIN_NAME	:= Print_api
PLUGIN_CMO	:= grammar lexer print_interface
PLUGIN_GENERATED:= $(PLUGIN_DIR)/grammar.ml $(PLUGIN_DIR)/grammar.mli \
		$(PLUGIN_DIR)/lexer.ml

include $(FRAMAC_SHARE)/Makefile.dynamic

clean:: 
	$(RM) $(Print_api_DIR)/dynamic_plugins.mli
	$(RM) $(Print_api_DIR)/grammar.output
	$(RM) $(Print_api_DIR)/grammar.ml
	$(RM) $(Print_api_DIR)/grammar.mli
	$(RM) $(Print_api_DIR)/lexer.ml
	$(RM) -r _build

=== src/plugins/wp/share/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of WP plug-in of Frama-C.                           #
#                                                                        #
#  Copyright (C) 2007-2015                                               #
#    CEA (Commissariat a l'energie atomique et aux energies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################


# --------------------------------------------------------------------------
# ---  Coq Compilation
# --------------------------------------------------------------------------

.PHONY: all why3compile coqwpcompile clean depend

WPLSHARE=$(Wp_DIR)/share

clean::
	find $(WPLSHARE) \( -name "*.vo" -or -name "*.glob" \) -print -delete
	rm -f $(WPLSHARE)/coqwp/.depend $(WPLSHARE)/why3/.depend

#########################
## For why3 directory ##

ifeq ($(WP_WHY3COQC_ENABLED),yes)

byte:: why3compile
opt:: why3compile

why3compile: $(addprefix $(WPLSHARE)/why3/, $(addsuffix o, $(COQ_LIBS_CEA)))

WHY3LIB:=$(shell why3 --print-libdir)
WHY3INCLUDES= -R $(WHY3LIB)/coq -as Why3 -I $(WPLSHARE)/why3

$(WPLSHARE)/why3/%.vo: $(WPLSHARE)/why3/%.v
	echo "Coqc         $@"
	@coqc $(WHY3INCLUDES) $<

$(WPLSHARE)/why3/.depend: $(addprefix $(WPLSHARE)/, $(WHY3_COQ_SOURCES))
	echo "Coqdep for $(WPLSHARE)/why3"
	@coqdep $(WHY3INCLUDES) -slash $(WPLSHARE)/why3/*.v $(WPLSHARE)/why3/**/*.v > $@

ifneq ($(MAKECMDGOALS),clean)
ifneq ($(MAKECMDGOALS),distclean)
ifneq ($(MAKECMDGOALS),smartclean)
include $(WPLSHARE)/why3/.depend
endif
endif
endif

endif # ($(WP_WHY3COQC_ENABLED),yes)

#########################
## For coqwp directory ##

ifeq ($(WP_COQC_ENABLED),yes)

byte:: coqwpcompile
opt:: coqwpcompile


coqwpcompile: $(addprefix $(WPLSHARE)/coqwp/, $(addsuffix o, $(COQ_LIBS_CEA) $(COQ_LIBS_INRIA)))

COQWPINCLUDES= -R $(WPLSHARE)/coqwp/ -as ""

$(WPLSHARE)/coqwp/%.vo: $(WPLSHARE)/coqwp/%.v
	echo "Coqc         $<"
	@coqc $(COQWPINCLUDES) $<

$(WPLSHARE)/coqwp/.depend: $(addprefix $(WPLSHARE)/, $(WP_COQ_SOURCES))
	echo "Coqdep for $(WPLSHARE)/coqwp"
	@coqdep $(COQWPINCLUDES) -slash $(WPLSHARE)/coqwp/*.v $(WPLSHARE)/coqwp/**/*.v > $@

ifneq ($(MAKECMDGOALS),clean)
ifneq ($(MAKECMDGOALS),distclean)
ifneq ($(MAKECMDGOALS),smartclean)
include $(WPLSHARE)/coqwp/.depend
endif
endif
endif

endif #($(WP_COQC_ENABLED),yes)

# End of file

##########################################################################
# Local Variables:
# mode: makefile
# End:

=== src/plugins/wp/qed/src/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of WP plug-in of Frama-C.                           #
#                                                                        #
#  Copyright (C) 2007-2015                                               #
#    CEA (Commissariat a l'energie atomique et aux energies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# --------------------------------------------------------------------------
# ---  QED : a prover / simplifier in classical logic modulo             ---
# --------------------------------------------------------------------------

PACK?=no

include Makefile.src

LIB_ML:=$(QED_LIB_ML)
SRC_ML:=$(QED_SRC_ML)
SRC_MLI:=$(QED_SRC_MLI)

LBO= $(addsuffix .cmo,$(LIB_ML))
LBX= $(addsuffix .cmx,$(LIB_ML))
CML= $(addsuffix .cmi,$(SRC_MLI))
CMO= $(addsuffix .cmo,$(SRC_ML))
CMX= $(addsuffix .cmx,$(SRC_ML))
CMI= $(addsuffix .cmi,$(LIB_ML) $(SRC_MLI) $(SRC_ML))
DOC= $(addsuffix .mli,$(LIB_ML) $(SRC_MLI) $(SRC_ML))

.PHONY: all byte opt doc dot

all:  byte opt
byte: ../bin/Qed.cmo Makefile Makefile.src
opt:  ../bin/Qed.cmx Makefile Makefile.src
doc:  ../html/index.html
dot:  depend.pdf

Qed.cmo: $(LBO) $(CMO) $(CML)
	$(OCAMLC) -pack -o $@ $(LBO) $(CML) $(CMO)

ifeq ($(PACK),no)
Qed.cmx: $(LBX) $(CMX) $(CML)
	$(OCAMLOPT) -pack -o $@ $(LBX) $(CML) $(CMX)
else
Qed.cmx: $(LBX) $(CMX) $(CML)
	$(OCAMLOPT) -pack -for-pack $(PACK) -o $@ $(LBX) $(CML) $(CMX)
endif

../bin/Qed.cmo: Qed.cmo
	@mkdir -p ../bin
	cp Qed.cmo Qed.cmi ../bin/

../bin/Qed.cmx: Qed.cmx
	@mkdir -p ../bin
	cp Qed.cmx Qed.cmi Qed.o ../bin/

../html/index.html: $(DOC) Makefile feedback.ml
	@rm -fr ../html
	@mkdir -p ../html
	$(OCAMLDOC) -v -html -d ../html -t "Qed Library" -stars $(DOC) | ocaml unix.cma feedback.ml
	@cp -f ocamldoc.css ../html/style.css

depend: numbers.ml

depend.pdf: depend.dot
	dot -T pdf -Grotate=180 -o $@ $<

depend.dot: .depend $(CMI)
	$(OCAMLDOC) -dot-reduce -o $@ -dot $(addsuffix .mli,$(SRC_MLI)) $(addsuffix .ml,$(LIB_ML) $(SRC_ML))

clean::
	rm -fr ../html
	rm -f depend.dot depend.pdf

distclean::
	rm -f ../bin/Qed.*

OPTML= -annot -w PSUZ+7-3 -warn-error PSUZ+7-3
INCLUDES=
OPTCMI=
OPTCMO=
ifeq ($(PACK),no)
OPTCMX= -for-pack Qed
else
OPTCMX= -for-pack $(PACK).Qed
endif

include MakeOcaml

=== tests/verisec/suite/programs/apps/Makefile ===
FRAMAC=frama-c
STUBS=../../lib/stubs.c
BIND_DIR=bind
BIND_CA_DIR=$(BIND_DIR)/CA-1999-14
BIND_RREXTRACT_NXT_DIR=$(BIND_CA_DIR)/rrextract-nxt

APACHE_DIR=apache
APACHE_2004_DIR=$(APACHE_DIR)/CVE-2004-0940

EDBROWSE_DIR=edbrowse/CVE-2006-6909/ftpls

GXINE_DIR=gxine/CVE-2007-0406/main

OPENSER_DIR=OpenSER
OPENSER_6876_DIR=$(OPENSER_DIR)/CVE-2006-6876/fetchsms

all:bind gxine apache edbrowse openser

bind:bind_CA bind_CVE

bind_CA:bind_rrextract_nxt

bind_rrextract_nxt:$(BIND_RREXTRACT_NXT_DIR)/simp_bad.c
	$(FRAMAC) -val $(STUBS) $(BIND_RREXTRACT_NXT_DIR)/simp_bad.c >$(BIND_RREXTRACT_NXT_DIR)/bin_rrextract_nxt.log 2>$(BIND_RREXTRACT_NXT_DIR)/bind_rrxtract_nxt.err

gxine:$(GXINE_DIR)/simp_bad.c
	$(FRAMAC) -val $(STUBS) $(GXINE_DIR)/simp_bad.c >$(GXINE_DIR)/frama-c.log  2>$(GXINE_DIR)/frama-c.err

bind_CVE:$(APACHE_2004_DIR)/apache.c

apache:apache_CVE_2004 apache_CVE_2006

apache_CVE_2004_iter1_prefixLong_arr: $(APACHE_2004_DIR)/apache.c
	$(FRAMAC) -val $(STUBS) $(APACHE_2004_DIR)/apache.c $(APACHE_2004_DIR)/get_tag/iter1_prefixLong_arr_bad.c  >$(APACHE_2004_DIR)/ap_iter1_prefixLong_arr.log 2>$(APACHE_2004_DIR)/ap_iter1_prefixLong_arr.err

apache_CVE_2004:apache_CVE_2004_iter1_prefixLong_arr

apache_CVE_2006:

edbrowse: $(EDBROWSE_DIR)/strchr_bad.c
	$(FRAMAC) -val $(STUBS) $(EDBROWSE_DIR)/strchr_bad.c >$(EDBROWSE_DIR)/strchr_bad.log 2>$(EDBROWSE_DIR)/strchr_bad.err

openser:openser_6876

openser_6876:$(OPENSER_6876_DIR)/full_bad.c
	$(FRAMAC) -val $(STUBS) $(OPENSER_6876_DIR)/full_bad.c -slevel 500 >$(OPENSER_6876_DIR)/full_bad.log 2>$(OPENSER_6876_DIR)/full_bad.err

=== debian/changelog ===
frama-c (20151002+magnesium+dfsg-1build1) xenial; urgency=medium

  * Rebuild for new GHC ABIs.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 04 Feb 2016 11:58:13 +0100

frama-c (20151002+magnesium+dfsg-1) unstable; urgency=medium

  * New upstream release
    - Refresh patches.
    - Add ocaml-findlib and libfindlib-ocaml-dev to Build-Depends
      since they became a hard requirement.
  * Fix variable FRAMA_GUI_LIBS in debian/rules: "gui" directory
    moved from "src" to "src/plugins".
  * Fix ocaml-dangling-cmx and ocaml-dangling-cmxa.

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 24 Jan 2016 00:33:56 +0100

=== debian/control ===
Source: frama-c
Section: devel
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Mehdi Dogguy <mehdi@debian.org>
Build-Depends:
 debhelper (>= 7.0.50~),
 ocaml-nox (>= 3.12.0~),
 ocaml-best-compilers,
 dh-ocaml (>= 0.9~),
 graphviz,
 autoconf,
 libzarith-ocaml-dev,
 ocaml-findlib,
 libfindlib-ocaml-dev,
 libocamlgraph-viewer-ocaml-dev (>> 1.8.5~),
 liblablgtk2-gnome-ocaml-dev (>= 2.14.0+dfsg-2~),
 liblablgtksourceview2-ocaml-dev (>= 2.14.0+dfsg-2~)
Standards-Version: 3.9.6
Homepage: http://frama-c.com/
Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/frama-c.git
Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/frama-c.git

Package: frama-c
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends},
 frama-c-base (= ${binary:Version}),
 graphviz,
 emacs | emacsen
Recommends:
 why (>= 2.19+dfsg-2),
Breaks:
 frama-c-base (<< 20150201+sodium+dfsg-1~)
Replaces:
 frama-c-base (<< 20150201+sodium+dfsg-1~)
Description: Framework for source code analysis of software written in C
 Frama-C is a framework dedicated to the analysis of the source code
 of software written in C.
 .
 Frama-C gathers several static analysis techniques in a single
 collaborative framework. The collaborative approach of Frama-C allows
 static analyzers to build upon the results already computed by other
 analyzers in the framework. Thanks to this approach, Frama-C provides
 sophisticated tools, such as a slicer and dependency analysis.
 .
 It can be used to:
   * Validate the source code formally
   * Look for potential runtime errors
   * Audit or review it
   * Reverse engineer it to understand its structure
   * Generate formal documentation
 .
 This package provides the graphical user interface of Frama-c and depends
 on frama-c-base.

Package: frama-c-base
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends},
 libocamlgraph-ocaml-dev,
 gcc,
Recommends:
 alt-ergo,
 libwhy-coq
Replaces: frama-c (<< 20090902+beryllium+dfsg-1)
Breaks: frama-c (<< 20090902+beryllium+dfsg-1)
Description: Framework for C source code analysis (without gui)
 Frama-C is a framework dedicated to the analysis of the source code
 of software written in C.
 .
 Frama-C gathers several static analysis techniques in a single
 collaborative framework. The collaborative approach of Frama-C allows
 static analyzers to build upon the results already computed by other
 analyzers in the framework. Thanks to this approach, Frama-C provides
 sophisticated tools, such as a slicer and dependency analysis.
 .
 It can be used to:
   * Validate the source code formally
   * Look for potential runtime errors
   * Audit or review it
   * Reverse engineer it to understand its structure
   * Generate formal documentation
 .
 This package provides the library of Frama-c which is useful to build
 plugins for Frama-c and the command-line tools.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

include /usr/share/ocaml/ocamlvars.mk

FRAMA_DIR=$(CURDIR)/debian/tmp
FRAMA_GUI_DIR=$(CURDIR)/debian/frama-c/usr/lib/frama-c
FRAMA_PLUGINS_DIR=$(CURDIR)/debian/frama-c-base/usr/lib/frama-c/plugins/

override_dh_auto_configure:
	mkdir -p lib/plugins
	mkdir -p lib/gui
	touch .depend .make-clean .make-clean-stamp
	[ ! -f src/kernel/config.ml ] || cp src/kernel/config.ml src/kernel/config.ml.debian
	autoconf
	./configure $(CROSS) --prefix=/usr       \
		--mandir=\$${prefix}/share/man   \
		--infodir=\$${prefix}/share/info \
		--datarootdir=\$${prefix}/share  \
		--disable-impact		 \
		--disable-security		 \
		--enable-verbosemake             \
		--enable-zarith="$(OCAML_STDLIB_DIR)/zarith" \
		CFLAGS="$(CFLAGS)"               \
		LDFLAGS="-Wl,-z,defs"

FRAMA_GUI_LIBS=$(patsubst src/plugins/gui/%.ml, $(FRAMA_DIR)/usr/lib/frama-c/%, $(wildcard src/plugins/gui/*.ml))
FRAMA_PLUGINS=$(wildcard lib/plugins/*.cmx lib/plugins/*.cmxa)

override_dh_auto_install:
	$(MAKE) prefix=$(FRAMA_DIR)/usr FRAMAC_DATADIR=$(FRAMA_DIR)/usr/share/frama-c install
	# Fix permission of .c and .h files (they don't have to be executable)
	find debian/ -name "*.c" -or -name "*.h" -exec chmod a-x '{}' \;
	# Install icons and desktop menu entry
	cp debian/icons/frama-c.svg $(CURDIR)/debian/frama-c/usr/share/icons/hicolor/scalable/apps/
	cp debian/icons/frama-c.xpm $(CURDIR)/debian/frama-c/usr/share/pixmaps/
	cp debian/frama-c.desktop $(CURDIR)/debian/frama-c/usr/share/applications/
	# Remove useless binaries
	$(RM) -f $(CURDIR)/debian/frama-c/usr/bin/frama-c-gui.byte
	$(RM) -f $(CURDIR)/debian/frama-c/usr/bin/ptests.byte
	# Same file as frama-c.1. We use a symlink instead of copying the file twice
	$(RM) -f $(FRAMA_DIR)/usr/share/man/man1/frama-c-gui.1
	# On Bytecode architectures, bin/frama-c.byte is sam as bin/frama-c
ifeq ($(OCAML_OPT_ARCH),)
	$(RM) -f $(CURDIR)/debian/frama-c/usr/bin/frama-c.byte
endif
	# Move GUI related objects in the appropriate package
	mkdir -p $(FRAMA_GUI_DIR)
	mv $(patsubst %, %.cmo, $(FRAMA_GUI_LIBS))      $(FRAMA_GUI_DIR)
	mv $(patsubst %, %.cmi, $(FRAMA_GUI_LIBS))      $(FRAMA_GUI_DIR)
ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
	mv $(patsubst %, %.cmx, $(FRAMA_GUI_LIBS))      $(FRAMA_GUI_DIR)
	mv $(patsubst %, %.o, $(FRAMA_GUI_LIBS))        $(FRAMA_GUI_DIR)
	mkdir -p $(FRAMA_PLUGINS_DIR)
	cp $(patsubst %.cmx, %.o, $(patsubst %.cmxa, %.a,$(FRAMA_PLUGINS))) \
							$(FRAMA_PLUGINS_DIR)
endif

override_dh_auto_clean:
	touch .depend
	[ ! -f src/kernel/config.ml.debian ] || mv src/kernel/config.ml.debian src/kernel/config.ml
	[ ! -f Makefile -o ! -f share/Makefile.config ] || $(MAKE) clean
	$(RM) -rf lib .depend

override_dh_ocaml:
	dh_ocaml --nodefined-map=frama-c-base:Big_int_Z,Z,Q

%:
	dh --with ocaml $@
